﻿package  {
	import flash.events.Event;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.utils.getTimer;
	import org.papervision3d.core.geom.renderables.Triangle3D;
	import org.papervision3d.core.geom.renderables.Vertex3D;
	import org.papervision3d.core.geom.TriangleMesh3D;
	import org.papervision3d.core.utils.Mouse3D;
	import org.papervision3d.events.InteractiveScene3DEvent;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.view.BasicView;


	/**
	 * 3D View
	 */
	public class World extends BasicView{
		private var  mesh:TriangleMesh3D ;
		/**
		 * コンストラクタ
		 */
		public function World() {
			super(600, 600, false);
			//初期化
			init();
			//フレームレート表示
			showFPS();
		}

		public function init() {
			//マウスに反応するように
			viewport.interactive = true;
			Mouse3D.enabled = true;
			//------------------------
			//メッシュのマテリアル
            var material:ColorMaterial = new ColorMaterial( 0x00AA00 );
			//メッシュを作成
            mesh = new TriangleMesh3D(material, [], []);
            scene.addChild( mesh );
			//------------------------
			//メインカメラ位置調整
			camera.fov = 30;
			camera.y = 400;
			camera.z = -800;
			camera.rotationX = 40;
			camera.target = mesh;
			//------------------------
			//床平面
			var bmd = new TextureBitmapData(16,16);
			var plane_material:BitmapMaterial = new BitmapMaterial(bmd, true);
			plane_material.interactive = true;
			var plane:Plane= new Plane( plane_material, 400, 400,10,10);
			plane.rotationX = 90;
			plane.addEventListener(InteractiveScene3DEvent.OBJECT_MOVE, onObjectMove);
			scene.addChild(plane);
			//描画開始
			startRendering();

		}
		//床平面上でマウスが動いた
		private function onObjectMove(e:InteractiveScene3DEvent):void {
			var x = viewport.interactiveSceneManager.mouse3D.x;
			var z = viewport.interactiveSceneManager.mouse3D.z;
			appendFace(x,z);
		}
		//メッシュ面生成
		private function appendFace(x:Number,z:Number) {
			//頂点作成
			var v0:Vertex3D = new Vertex3D( x-25, 0, z ) ;
			var v1:Vertex3D = new Vertex3D( x+25, 0, z ) ;
			var v2:Vertex3D = new Vertex3D( x, 50, z );
			//表面からみて反時計周りになるように点を選ぶ
			var vertices:Array = [v0, v1, v2];
			//meshに頂点追加
			mesh.geometry.vertices=mesh.geometry.vertices.concat(vertices);
            //meshに面追加
            mesh.geometry.faces.push( new Triangle3D(mesh, vertices));
			//頂点の法線計算実行
			//mesh.geometry.ready = true;
		}

		override protected function onRenderTick(event:Event = null):void {

			super.onRenderTick();	
		}
		
		//---------------------------
		//以下、フレームレート計算用
		private	var fps_text:TextField = new TextField();
		private var update_time = 500;
		private	var draw_count = 0;
		private	var old_timer = getTimer();
		private function showFPS():void{
			fps_text.background = true;
			fps_text.selectable = false;
			fps_text.width = 70;
			fps_text.height = 18;
			this.addChild (fps_text);
			this.addEventListener(Event.ENTER_FRAME , onFPS);
		}
		private function onFPS(e:Event):void{
			draw_count += 1;
			if (getTimer()-old_timer >= update_time) {
				var fps = draw_count * 1000 / (getTimer() - old_timer);
				fps = Math.floor(fps * 10) / 10;  
				fps_text.text ="FPS:"+ fps + ' / ' + fps_text.stage.frameRate;
				old_timer = getTimer();
				draw_count = 0;
			}
		}
	}
}
